#ifndef MECHBCLC_H
#define MECHBCLC_H

#include "iotools.h"

class inicd;
class loadcase;
class dloadcase;

/**
  Class mechbclc:
   
  It is one of the 5 most important classes of the program.
  (probdesc, mechtop, mechmat, mechbclc, mechcrsec)
   
  Class mechbclc contains data about boundary conditions, load cases.
   
  Created by JK, TKo
*/
class mechbclc
{
 public:
  mechbclc ();
  ~mechbclc ();
  void read (XFILE *in);
  long readinic (XFILE *in);
  void inicipval(void);
  void alloc_sumcomp ();
  void comp_sum (double *rhs);
  void give_comp_sum (double *sum);
  void comp_sum_react();
  void comp_sum_pdreact();

  /// number of load cases
  long nlc;
  /// number of initcond
  long nico;
  
  ///  number of components of array sumcomp
  long ncsum;
  ///  array containing sums of components of load %vector in particular directions 
  double *sumcomp;
  ///  array containing sums of components of reactions at supports in particular directions 
  double *reactsumcomp;
  ///  array containing sums of components of reactions at prescribed displacements in particular directions 
  double *pd_reactsumcomp;
  
  /// array of static load cases
  loadcase  *lc;
  /// array of time dependent load cases
  dloadcase *dlc;
  /// array of initial conditions
  inicd     *ico;
};

#endif
