#ifndef SEQUENT_H
#define SEQUENT_H

#include <stdio.h>
#include "alias.h"
struct vector;


/// creates list of adjacent integration points
void adjacip (void);

/// saves list of adjacent integration points
void save_adjacip();
/// restores list of adjacent integration points
long restore_adjacip();
/// saves list of adjacent integration points in a text file
void save_adjacip_txt(FILE *aux);
/// saves list of adjacent integration points in a binary file
void save_adjacip_bin(FILE *aux);
/// restores list of adjacent integration points in a text file
void restore_adjacip_txt(FILE *aux);
/// restores list of adjacent integration points in a binary file
void restore_adjacip_bin(FILE *aux);

/// returns estimated number of adjacent integration points
long give_max_adjacip();
/// reallocates memory for onedimensional array of long
void reallocate(long *&array, long req_size, long &capacity);
/// computes number of non-eliminated adjacent elements
void newnadjelel (long ipp,long *adjelelback,long *adjelel,long &nae,long &nnae);
/// creates list of adjacent elements
void newadjelel (long *adjelelback,long *adjelel,long &nae,long &nnae,long *treatedel,long &nte);
/// computes number of adjacent integration points closer than given limit
void in_dist (long ipp,long ri,long ci,vector &coord,long *adjelel,long &nae,double rlim);
/// computes distances of adjacent integration points closer than given limit
void dist (long ipp,long ri,long ci,long max_nadjip,vector &coord,long *adjelel,long &nae,double rlim);
/// function computes coordinates of the given integration point
void ipcoord (long eid,long ipp,long ri,long ci,vector &ipcoord);

#endif
